<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_FareGroupPriceApplication ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_FareGroupPriceApplication extends AbstractStructArrayBase
{
    /**
     * The FareGroupPriceApplication
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_FareGroupPriceApplication[]
     */
    public $FareGroupPriceApplication;
    /**
     * Constructor method for ArrayOfJP_FareGroupPriceApplication
     * @uses ArrayOfJP_FareGroupPriceApplication::setFareGroupPriceApplication()
     * @param \StructType\JP_FareGroupPriceApplication[] $fareGroupPriceApplication
     */
    public function __construct(array $fareGroupPriceApplication = array())
    {
        $this
            ->setFareGroupPriceApplication($fareGroupPriceApplication);
    }
    /**
     * Get FareGroupPriceApplication value
     * @return \StructType\JP_FareGroupPriceApplication[]|null
     */
    public function getFareGroupPriceApplication()
    {
        return $this->FareGroupPriceApplication;
    }
    /**
     * This method is responsible for validating the values passed to the setFareGroupPriceApplication method
     * This method is willingly generated in order to preserve the one-line inline validation within the setFareGroupPriceApplication method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFareGroupPriceApplicationForArrayConstraintsFromSetFareGroupPriceApplication(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_FareGroupPriceApplicationFareGroupPriceApplicationItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_FareGroupPriceApplicationFareGroupPriceApplicationItem instanceof \StructType\JP_FareGroupPriceApplication) {
                $invalidValues[] = is_object($arrayOfJP_FareGroupPriceApplicationFareGroupPriceApplicationItem) ? get_class($arrayOfJP_FareGroupPriceApplicationFareGroupPriceApplicationItem) : sprintf('%s(%s)', gettype($arrayOfJP_FareGroupPriceApplicationFareGroupPriceApplicationItem), var_export($arrayOfJP_FareGroupPriceApplicationFareGroupPriceApplicationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The FareGroupPriceApplication property can only contain items of type \StructType\JP_FareGroupPriceApplication, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set FareGroupPriceApplication value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupPriceApplication[] $fareGroupPriceApplication
     * @return \ArrayType\ArrayOfJP_FareGroupPriceApplication
     */
    public function setFareGroupPriceApplication(array $fareGroupPriceApplication = array())
    {
        // validation for constraint: array
        if ('' !== ($fareGroupPriceApplicationArrayErrorMessage = self::validateFareGroupPriceApplicationForArrayConstraintsFromSetFareGroupPriceApplication($fareGroupPriceApplication))) {
            throw new \InvalidArgumentException($fareGroupPriceApplicationArrayErrorMessage, __LINE__);
        }
        $this->FareGroupPriceApplication = $fareGroupPriceApplication;
        return $this;
    }
    /**
     * Add item to FareGroupPriceApplication value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_FareGroupPriceApplication $item
     * @return \ArrayType\ArrayOfJP_FareGroupPriceApplication
     */
    public function addToFareGroupPriceApplication(\StructType\JP_FareGroupPriceApplication $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_FareGroupPriceApplication) {
            throw new \InvalidArgumentException(sprintf('The FareGroupPriceApplication property can only contain items of type \StructType\JP_FareGroupPriceApplication, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->FareGroupPriceApplication[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_FareGroupPriceApplication|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_FareGroupPriceApplication|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_FareGroupPriceApplication|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_FareGroupPriceApplication|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_FareGroupPriceApplication|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string FareGroupPriceApplication
     */
    public function getAttributeName()
    {
        return 'FareGroupPriceApplication';
    }
}
